/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003-2005 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2005/02/27 FreeNote 1.11.10pre
EPDF̏o͌`ꕔύX
EC|[g̃oOfix

2004/12/25 @\ǉ
*/
#include <qlineedit.h>
#include <qlist.h>
#include <qlistbox.h>
#include <qcheckbox.h>
#include <qmessagebox.h>
#include "fnlayerdlg.h"
#include "fnpolygon.h"
FNLayerDlg::FNLayerDlg( QWidget* parent, const char* name, bool modal, WFlags fl)
:FNLayerDlgBase(parent, name, modal, fl)
{
	_canvas = (FNCanvas*)parent;
	_selIdx = _canvas->_selIdx;
	_isNeedToBuild = true;
	rebuildList();
	FNLayerList& layers = _canvas->Layers();
	LstLayer->setSelected(layers.count() - 1 - _selIdx, true);
	
}

FNLayerDlg::~FNLayerDlg()
{
	//Ȃ
}

void  FNLayerDlg::rebuildList()
{
	LstLayer->clear();
	FNLayerList& layers = _canvas->Layers();
	char cvbuf[1024];
	int max = layers.count() - 1;
	for (uint i = 0; i < layers.count(); ++i) {
		FNLayer& layer = *layers.at(i);
		if (_canvas->isTinyPaging()) {
				sprintf(cvbuf, "%3d * ", max - i);
		} else {
			if (layer.IsShow) {
				sprintf(cvbuf, "%3d + ", max - i);
			} else {
				sprintf(cvbuf, "%3d - ", max - i);
			}
		}
		QString name = cvbuf;
		name += layer.Name;
		LstLayer->insertItem(name, 0);
	}
}

void FNLayerDlg::AddLayer()
{
	FNLayer* layer = new FNLayer();
	FNLayerList& layers = _canvas->Layers();
	uint cnt = layers.count();
	while (1) {
		QString name = "Layer";
		name += QString::number(cnt);

		bool nameExists = false;
		for (uint i = 0; i < layers.count(); ++i) {
			if (layers.at(i)->Name == name) {
				nameExists = true;
				break;
			}
		}
		if (false == nameExists) {
			layer->Name = name;
			break;
		}
		++cnt;
	}
	layers.append(layer);
	rebuildList();
	LstLayer->setSelected(0, true);
}

void FNLayerDlg::DelLayer()
{
	FNLayerList& layers = _canvas->Layers();
	if (1 == layers.count()) {
		return;
	}
	FNLayer* layer = layers.at(_selIdx);
	layers.remove(layer);
	if (_selIdx >= (int)layers.count()) {
		--_selIdx;
	}
	rebuildList();
	LstLayer->setSelected(layers.count() - 1 - _selIdx, true);
	_canvas->redraw();
}

void FNLayerDlg::DownLayer()
{
	FNLayerList& layers = _canvas->Layers();
	if (1 >= (int)layers.count() || 0 == _selIdx) {
		return;
	}
	FNLayer* layer1 = layers.at(_selIdx);
	FNLayer* layer2 = layers.at(_selIdx - 1);

	--_selIdx;
	layers.setAutoDelete(false);
	layers.remove(layer1);
	layers.remove(layer2);
	layers.insert(_selIdx, layer2);
	layers.insert(_selIdx, layer1);
	layers.setAutoDelete(true);
	_canvas->redraw();
	rebuildList();
	LstLayer->setSelected(layers.count() - 1 - _selIdx, true);
}

void FNLayerDlg::IsShowToggled(bool v)
{
	FNLayerList& layers = _canvas->Layers();
	layers.at(_selIdx)->IsShow = v;
	_canvas->redraw();
	if (_isNeedToBuild) {
		rebuildList();
		LstLayer->setSelected(layers.count() - 1 - _selIdx, true);
	}
}

void FNLayerDlg::LstSelected(QListBoxItem* v)
{
	_selIdx = _canvas->Layers().count() - (LstLayer->index(v) + 1);
	_canvas->_selIdx = _selIdx;
	FNLayer* layer = _canvas->Layers().at(_selIdx);
	LEdLayerName->setText(layer->Name);
	if (!_canvas->isTinyPaging()) {
		_isNeedToBuild = false;
		CkbShow->setChecked(layer->IsShow);
		_isNeedToBuild = true;
	}
	_canvas->_current = layer;
	if (_canvas->isTinyPaging()) {
		FNLayerList& layers = _canvas->Layers();
		for (uint i = 0; i < layers.count(); ++i) {
			FNLayer* l = layers.at(i);
			if (_canvas->_current == l) {
				l->IsShow = true;
			} else {
				l->IsShow = false;
			}
		}
		_isNeedToBuild = false;
		CkbShow->setChecked(layer->IsShow);
		_isNeedToBuild = true;
		//_canvas->redraw();
	}
}

void FNLayerDlg::NameEnter()
{
	FNLayerList& layers = _canvas->Layers();
	layers.at(_selIdx)->Name = LEdLayerName->text();
	rebuildList();
	LstLayer->setSelected(layers.count() - 1 - _selIdx, true);
}

void FNLayerDlg::UpLayer()
{
	FNLayerList& layers = _canvas->Layers();
	if (1 >= layers.count() || (int)layers.count() - 1 == _selIdx) {
		return;
	}
	FNLayer* layer1 = layers.at(_selIdx);
	FNLayer* layer2 = layers.at(_selIdx + 1);

	layers.setAutoDelete(false);
	layers.remove(layer1);
	layers.remove(layer2);
	layers.insert(_selIdx, layer1);
	layers.insert(_selIdx, layer2);
	layers.setAutoDelete(true);
	++_selIdx;
	_canvas->redraw();
	rebuildList();
	LstLayer->setSelected(layers.count() - 1 - _selIdx, true);
}

void FNLayerDlg::ConnectLayer() {
	FNLayerList& layers = _canvas->Layers();
	if (1 >= layers.count()) {
		return;
	}
	FNLayer* top = new FNLayer();
	FNLayerList remv;
	QString name = "";
	for (uint i = 0; i < layers.count(); ++i) {
		FNLayer* layer = layers.at(i);
		if (layer->IsShow) {
			layer->redobuf_flush();
			top->Name = layer->Name;
			for (uint j = 0; j < layer->draws.count(); ++j) {
				top->draws.append(layer->draws.at(j));
			}
			layer->draws.setAutoDelete(false);
			layer->draws.clear();
			remv.append(layer);
		}
	}
	layers.setAutoDelete(false);
	for (uint i = 0; i < remv.count(); ++i) {
		layers.remove(remv.at(i));
	}
	layers.setAutoDelete(true);
	layers.append(top);
	remv.setAutoDelete(true);
	remv.clear();
	rebuildList();
	LstLayer->setSelected(0, true);
}
