/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003-2005 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2005/02/27 FreeNote 1.11.10pre
EPDF̏o͌`ꕔύX
EC|[g̃oOfix

2004/10/17 FreeNote 1.10.0[X
2003/12/19 FreeNote 1.5.5pre
EȐ`惍WbN̉

2003/12/14 FreeNote 1.5.4pre
EȐ`惍WbN̉

2003/11/16 FreeNote 1.5.2pre
E~`̃WbNǉ

2003/11/13 FreeNote 1.5.1pre
EX[WOǉ

2003/11/09 ǉ
*/
#ifndef FmtEngine_H
#define FmtEngine_H
#include "fnpolygon.h"
extern int SNAP_SIZE;
extern int PHASE1_ANGLE;
extern int PHASE2_ANGLE;

double Surface(const QPoint& p1, const QPoint& p2);
bool IsLinear(const QPoint& p1, const QPoint& p2, const QPoint& p3);
const double Angle(const QPoint& p1, const QPoint& p2);
const double DiffAngle(const QPoint& p1, const QPoint& p2, const QPoint& p3);
const double DiffAngle(double a1, double a2);
const double DiffAngle2(double a1, double a2);
const double ToDegree(double t);
const double ToRadian(double d);
const double Distance(const QPoint& p1, const QPoint& p2);
FNPointList ReducePoints(FNPointList& p);
FNPointList ExtractAngle(FNPointList& p, const int deg);
FNPointList ExtractAngle2(FNPointList& p, const int deg);
FNPointList SumupPoints(FNPointList& p);
const QPoint OffCurvePoint(const QPoint& p1, const QPoint& p2, const QPoint& p3);
const QPoint SnapPoint(const QPoint& p, int snap);
const QPoint SnapPoint(const QPoint& p);
FNPointList SnapPoints(FNPointList& p);
const QPoint ArrangePoint(const QPoint& p1, const QPoint& p2);
FNPointList ArrangePoints(FNPointList& p);
FNPointList ToBezeir(FNPointList& p);
FNPointList ToCurves(FNPointList& p);
FNPointList ToEllipse(int x, int y, int w, int h);
FNPointList AutoFormat(FNPointList& p);
FNPointList AutoCurve(FNPointList& p);
FNPointList Smoothing(FNPointList& p);
FNPointList Reduce(FNPointList& p);
QRect GetBounds(FNPointList& v);
FNPointList Translate(FNPointList& v, int x, int y, double xs = 1.0, double ys = 1.0);
double ToStrokeDeg(double v);
int sign(int v);
#endif //FormatEngine_H
