/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003-2005 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2005/02/27 FreeNote 1.11.10pre
EPDF̏o͌`ꕔύX
EC|[g̃oOfix

2004/10/17 FreeNote 1.10.0[X
2003/08/15 FreeNote 1.2.1J
Eۑ̃oOC
E_CAO̎
EPNGt@Cւ̏o
*/
#ifndef FNMESSAGEBOX_H
#define FNMESSAGEBOX_H
#include <qmessagebox.h>
#include <qtimer.h>
extern int ___fnmessagebox_timing;
class FNMessageBox : public QMessageBox {
	Q_OBJECT
public:
	FNMessageBox(QWidget *parent=0, const char* name=0);
	FNMessageBox(const QString& caption, const QString& text, Icon icon, int button0, int button1, int button2, QWidget* parent=0, const char* name=0, bool modal=TRUE, WFlags f=WStyle_DialogBorder);
	virtual ~FNMessageBox();
	static int information(QWidget* parent, const QString& caption, const QString& text, int button0, int button1=0, int button2=0);
	static int information(QWidget* parent, const QString& caption, const QString& text, const QString& button0Text=QString::null, const QString& button1Text=QString::null, const QString& button2Text=QString::null, int defaultButtonNumber=0, int escapeButtonNumber=-1);
	static int warning(QWidget* parent, const QString& caption, const QString& text, int button0, int button1, int button2=0);
	static int warning(QWidget* parent, const QString& caption, const QString& text, const QString& button0Text=QString::null, const QString& button1Text=QString::null, const QString& button2Text=QString::null, int defaultButtonNumber=0, int escapeButtonNumber=-1);
	static int critical(QWidget* parent, const QString& caption, const QString& text, int button0, int button1, int button2=0);
	static int critical(QWidget* parent, const QString& caption, const QString& text, const QString& button0Text=QString::null, const QString& button1Text=QString::null, const QString& button2Text=QString::null, int defaultButtonNumber=0, int escapeButtonNumber=-1);
	static void about(QWidget* parent, const QString& caption, const QString& text);
	static void about(QWidget* parent, const QString& caption=QString::null);
public:
	static void setTiming(const int v);
private slots:
	void timeout();
protected:
	virtual void showEvent(QShowEvent* ext);
private:
	QTimer* _timer;
};
#endif //FNMESSAGEBOX_H
