/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003-2005 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2005/02/27 FreeNote 1.11.10pre
EPDF̏o͌`ꕔύX
EC|[g̃oOfix

2004/10/17 FreeNote 1.10.0[X
2004/06/30 ver 1.9.2pre
EFNOptionData𕪗
*/
#ifndef FNOPTIONDATA_H
#define FNOPTIONDATA_H
#include <qpe/config.h>
#include <qcolor.h>

class FNOptionData {
public:
	FNOptionData() {
		timing = 800;
		v_step = 100;
		h_step = 100;
		margin = 5;
		eraser_s = 10;
		eraser_l = 50;
		isMaximizedOn = true;
		isLMvAOn = true;
		isLMvBOn = true;
		isLAddOn = true;
		isFindOn = true;
		//isPaletteOn = true;
		isCopyOn = true;
		isPasteOn = true;
		isImportOn = true;
		isUndoOn = true;
		isRedoOn = true;
		isBoldOn = true;
		isColorOn = true;
		isZoomOn = true;
		isCROn = false;
		isGuideOn = true;
		isNewOn = false;
		isClearOn = false;
		isOpenOn = false;
		isSaveOn = true;
		isExportOn = false;
		isExportPNGOn = false;
		//isOptionOn = false;
		isLayerOn = false;
		scrollMode = 3;//AS_BOTH;
		isAutoScrollEnabled = false;
		useAllQuadrant = false;
		isShowRuler = false;
		phase1 = 30;
		phase2 = 30;
		grid_size = 32;
		isQuitQuickly = false;
		//isTinyPaging = false;
		for (int i = 0; i < 8; ++i) {
			toolNames << "";
			toolScripts << "";
		}
		selectionLineColor.setNamedColor("#969696");
		selectionBrushColor.setNamedColor("#646464");
		selectionFrameColor.setNamedColor("#969696");
		rulerColor.setNamedColor("#C8C8C8");
		guideColor.setNamedColor("#00FFFF");
		gridColor.setNamedColor("#32F0F0");
	};
	void load()
	{
		Config conf("FreeNoteQt");
		conf.setGroup("Scroll");
		useAllQuadrant = conf.readBoolEntry("useAllQuadrant", false);
		isShowRuler = conf.readBoolEntry("isShowRuler", false);
		timing = conf.readNumEntry("timing", 800);
		v_step = conf.readNumEntry("v_step", 100);
		h_step = conf.readNumEntry("h_step", 100);
		margin = conf.readNumEntry("margin", 5);
		scrollMode = conf.readNumEntry("scrollMode", 3/*AS_BOTH*/);
		isAutoScrollEnabled = conf.readBoolEntry("autoScrollEnabled", false);
		conf.setGroup("Eraser");
		eraser_s = conf.readNumEntry("eraser_s", 10);
		eraser_l = conf.readNumEntry("eraser_l", 50);
		conf.setGroup("Toolbar");
		isMaximizedOn = conf.readBoolEntry("isMaximizedOn", true);
		isLMvAOn = conf.readBoolEntry("isLMvAOn", true);
		isLMvBOn = conf.readBoolEntry("isLMvBOn", true);
		isLAddOn = conf.readBoolEntry("isLAddOn", true);
		isFindOn = conf.readBoolEntry("isFindOn", true);
		//isPaletteOn = conf.readBoolEntry("isPaletteOn", true);
		isCopyOn = conf.readBoolEntry("isCopyOn", true);
		isPasteOn = conf.readBoolEntry("isPasteOn", true);
		isImportOn = conf.readBoolEntry("isImportOn", true);
		isUndoOn = conf.readBoolEntry("isUndoOn", true);
		isRedoOn = conf.readBoolEntry("isRedoOn", true);
		isBoldOn = conf.readBoolEntry("isBoldOn", true);
		isColorOn = conf.readBoolEntry("isColorOn", true);
		isZoomOn = conf.readBoolEntry("isZoomOn", true);
		isGuideOn = conf.readBoolEntry("isGuideOn", true);
		isCROn = conf.readBoolEntry("isCROn", false);
		isNewOn = conf.readBoolEntry("isNewOn", false);
		isClearOn = conf.readBoolEntry("isClearOn", false);
		isOpenOn = conf.readBoolEntry("isOpenOn", false);
		isSaveOn = conf.readBoolEntry("isSaveOn", true);
		isExportOn = conf.readBoolEntry("isExportOn", false);
		isExportPNGOn = conf.readBoolEntry("isExportPNGOn", false);
		//isOptionOn = conf.readBoolEntry("isOptionOn", true);
		isLayerOn = conf.readBoolEntry("isLayerOn", false);
		conf.setGroup("AutoFormat");
		phase1 = conf.readNumEntry("phase1", 30);
		phase2 = conf.readNumEntry("phase2", 30);
		grid_size = conf.readNumEntry("grid_size", 32);
		isQuitQuickly = conf.readBoolEntry("isQuitQuickly", false);
		encode = conf.readEntry("encode", "UniJIS-UCS2-H");
		fontname = conf.readEntry("fontname", "lcfont");
		isColorRevision = conf.readBoolEntry("isColorRevision", true);
		//isTinyPaging = conf.readBoolEntry("isTinyPaging", false);
		toolNames.clear();
		toolScripts.clear();
		for (int i = 0; i < 8; ++i) {
			toolNames << conf.readEntry("ToolName" + QString::number(i), "");
			toolScripts << conf.readEntry("ToolScript" + QString::number(i), "");
		}
		wkdir = conf.readEntry("wkdir", "");
		conf.setGroup("TextBox");
		txtBoxRect.setX(conf.readNumEntry("x", 0));
		txtBoxRect.setY(conf.readNumEntry("y", 0));
		txtBoxRect.setWidth(conf.readNumEntry("width", 200));
		txtBoxRect.setHeight(conf.readNumEntry("height", 240));
		selectionLineColor.setNamedColor(conf.readEntry("selectionLineColor", "#969696"));
		selectionBrushColor.setNamedColor(conf.readEntry("selectionBrushColor", "#646464"));
		selectionFrameColor.setNamedColor(conf.readEntry("selectionFrameColor", "#969696"));
		rulerColor.setNamedColor(conf.readEntry("rulerColor", "#C8C8C8"));
		guideColor.setNamedColor(conf.readEntry("guideColor", "#00FFFF"));
		gridColor.setNamedColor(conf.readEntry("gridColor", "#32F0F0"));
	};

	void save()
	{
		Config conf("FreeNoteQt");
		conf.setGroup("Scroll");
		conf.writeEntry("useAllQuadrant", useAllQuadrant);
		conf.writeEntry("isShowRuler", isShowRuler);
		conf.writeEntry("timing", timing);
		conf.writeEntry("v_step", v_step);
		conf.writeEntry("h_step", h_step);
		conf.writeEntry("margin", margin);
		conf.writeEntry("scrollMode", scrollMode);
		conf.writeEntry("autoScrollEnabled", isAutoScrollEnabled);
		conf.setGroup("Eraser");
		conf.writeEntry("eraser_s", eraser_s);
		conf.writeEntry("eraser_l", eraser_l);
		conf.setGroup("Toolbar");
		conf.writeEntry("isMaximizedOn", isMaximizedOn);
		conf.writeEntry("isLMvAOn", isLMvAOn);
		conf.writeEntry("isLMvBOn", isLMvBOn);
		conf.writeEntry("isLAddOn", isLAddOn);
		conf.writeEntry("isFindOn", isFindOn);
		//conf.writeEntry("isPaletteOn", isPaletteOn);
		conf.writeEntry("isCopyOn", isCopyOn);
		conf.writeEntry("isPasteOn", isPasteOn);
		conf.writeEntry("isImportOn", isImportOn);
		conf.writeEntry("isUndoOn", isUndoOn);
		conf.writeEntry("isRedoOn", isRedoOn);
		conf.writeEntry("isBoldOn", isBoldOn);
		conf.writeEntry("isColorOn", isColorOn);
		conf.writeEntry("isZoomOn", isZoomOn);
		conf.writeEntry("isCROn", isCROn);
		conf.writeEntry("isGuideOn", isGuideOn);
		conf.writeEntry("isNewOn", isNewOn);
		conf.writeEntry("isClearOn", isClearOn);
		conf.writeEntry("isOpenOn", isOpenOn);
		conf.writeEntry("isSaveOn", isSaveOn);
		conf.writeEntry("isExportOn", isExportOn);
		conf.writeEntry("isExportPNGOn", isExportPNGOn);
		//conf.writeEntry("isOptionOn", isOptionOn);
		conf.writeEntry("isLayerOn", isLayerOn);
		conf.setGroup("AutoFormat");
		conf.writeEntry("phase1", phase1);
		conf.writeEntry("phase2", phase2);
		conf.writeEntry("grid_size", grid_size);
		conf.writeEntry("isQuitQuickly", isQuitQuickly);
		conf.writeEntry("encode", encode);
		conf.writeEntry("fontname", fontname);
		conf.writeEntry("isColorRevision", isColorRevision);
		//conf.writeEntry("isTinyPaging", isTinyPaging);
		for (int i = 0; i < 8; ++i) {
			conf.writeEntry("ToolName" + QString::number(i), toolNames[i]);
			conf.writeEntry("ToolScript" + QString::number(i), toolScripts[i]);
		}
		conf.writeEntry("wkdir", wkdir);
		conf.setGroup("TextBox");
		conf.writeEntry("x", txtBoxRect.x());
		conf.writeEntry("y", txtBoxRect.y());
		conf.writeEntry("width", txtBoxRect.width());
		conf.writeEntry("height", txtBoxRect.height());
		conf.writeEntry("selectionLineColor",selectionLineColor.name());
		conf.writeEntry("selectionBrushColor",selectionBrushColor.name());
		conf.writeEntry("selectionFrameColor",selectionFrameColor.name());
		conf.writeEntry("rulerColor",rulerColor.name());
		conf.writeEntry("guideColor",guideColor.name());
		conf.writeEntry("gridColor",gridColor.name());
	};

	~FNOptionData()
	{
	};
	
	int timing;
	int v_step;
	int h_step;
	int margin;
	int eraser_s;
	int eraser_l;
	int phase1;
	int phase2;
	int grid_size;
	bool isMaximizedOn;
	bool isLMvAOn;
	bool isLMvBOn;
	bool isLAddOn;
	bool isFindOn;
	//bool isPaletteOn;
	bool isCopyOn;
	bool isPasteOn;
	bool isImportOn;
	bool isUndoOn;
	bool isRedoOn;
	bool isBoldOn;
	bool isColorOn;
	bool isZoomOn;
	bool isCROn;
	bool isGuideOn;
	bool isNewOn;
	bool isClearOn;
	bool isOpenOn;
	bool isSaveOn;
	bool isExportOn;
	bool isExportPNGOn;
	//bool isOptionOn;
	bool isLayerOn;
	int scrollMode;
	bool isAutoScrollEnabled;
	bool useAllQuadrant;
	bool isQuitQuickly;
	QString encode;
	QString fontname;
	QStringList toolNames;
	QStringList toolScripts;
	QString wkdir;
	bool isShowRuler;
	QRect txtBoxRect;
	bool isColorRevision;
	//bool isTinyPaging;
	QColor selectionLineColor;
	QColor selectionBrushColor;
	QColor selectionFrameColor;
	QColor rulerColor;
	QColor guideColor;
	QColor gridColor;
};
#endif //FNOPTIONDATA_H
