/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003-2005 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2005/06/04 FreeNote 1.11.12pre
EObh̘gۂ̑I͈͂傫\悤ɕύXB
E͈͑IAObhAKChArJ[̃JX^}CY\ɁB
EJ[sbJ[[h̒ǉ

2005/06/02 FreeNote 1.11.11Apre
EeLXgړg̕sC
ErObĥQ{ŕ\悤ɕύX
ES͈͎̔w莞ɁAyItăe|Ă͈͊m肷悤ɕύX

2005/02/27 FreeNote 1.11.10pre
EPDF̏o͌`ꕔύX
EC|[g̃oOfix

2004/10/17 FreeNote 1.10.0[X
2004/02/14 ver 1.7.2pre
E@\ǉ

2004/02/12 ver 1.7.1pre
EtHgdl̕ύX
EeLXg̍

2004/02/10 ver 1.7.0pre
E

2003/12/22 ver 1.6.1
Ef[^\̌î݁xWFAȉ~ցj

2003/08/17-20 ver 1.3.0
Ef[^̏ki̓_Ȃj

2003/08/05 FreeNote 1.1.1preJ
ENɕԂێ
E`惂[hؑւɏS\
EۑԒZk
EView[h̋ύX
Ej[̌ڂύX
*/
#ifndef FNPOLYGON_H
#define FNPOLYGON_H
#include <qpen.h>
#include <qpointarray.h>
#include <qpainter.h>
#include <qlist.h>
#include <qstringlist.h>
#include <qfont.h>
#include <qcolor.h>

#define FN_POLYGON 0
#define FN_BEZIER 1
#define FN_ELLIPSE 2
#define FN_TEXT 3
extern const int FONTSIZE[];

extern QColor SelectionLineColor;
extern QColor SelectionBrushColor;
extern QColor SelectionFrameColor;
extern QColor RulerColor;
extern QColor GuideColor;
extern QColor GridColor;

typedef QList<QPoint> FNPointList;

class Q_EXPORT FNPolygon
{
public:
	FNPolygon(QPen& p);
	FNPolygon();
	FNPolygon(const FNPolygon& p);
	FNPolygon& operator=(const FNPolygon& p);
	virtual ~FNPolygon();
	
	virtual void setPoints(FNPointList& list);
	//virtual void drawShape(QPainter& pa);
	virtual void drawShape(QPainter& pa, bool selected = false);
	virtual void translate(int dx, int dy);
	QPointArray& points() {return _points;};
	QRect boundingRect() const;
	QPen& pen() {return _pen;};
	const int type() const {return _type;};
	const bool fill() const {return _fill;};
	void setFill(const bool f) {_fill = f;};
protected:
	QPen _pen;
	QPointArray _points;
	int _type;
	bool _fill;
};
//typedef QList<FNPolygon> FNPolygonList;

class Q_EXPORT FNBezier : public FNPolygon
{
public:
	FNBezier(QPen& p);
	FNBezier();
	FNBezier(const FNBezier& p);
	FNBezier& operator=(const FNBezier& p);
	virtual ~FNBezier();
	//virtual void drawShape(QPainter& pa);
	virtual void drawShape(QPainter& pa, bool selected);
};

class Q_EXPORT FNEllipse : public FNPolygon
{
public:
	FNEllipse(QPen& p);
	FNEllipse();
	FNEllipse(const FNEllipse& p);
	FNEllipse& operator=(const FNEllipse& p);
	virtual ~FNEllipse();
	//virtual void drawShape(QPainter& pa);
	virtual void drawShape(QPainter& pa, bool selected);
};

class Q_EXPORT FNText : public FNPolygon
{
public:
	FNText(QPen& p);
	FNText();
	FNText(const FNText& p);
	FNText& operator=(const FNText& p);
	virtual ~FNText();
	//virtual void drawShape(QPainter& pa);
	virtual void drawShape(QPainter& pa, bool selected);
	QStringList lines;
};

class FNPolygonList : public QList<FNPolygon>
{
public:
	void copy(FNPolygonList& lst);
	void clone(FNPolygonList& lst);
};

class Q_EXPORT FNLayer
{
public:
	FNLayer();
	FNLayer(FNLayer& v);
	virtual ~FNLayer();
	FNLayer& operator=(FNLayer& v);

	uint disp_offset();
	void undo();
	void redo();
	void redobuf_flush();
	void modeChanged();

	FNPolygonList draws;
	bool IsShow;
	QString Name;
private:
	uint _disp_offset;
};
typedef QList<FNLayer> FNLayerList;

//typedef QList<FNPolygon> FNPolygonList;


#endif //FNPOLYGON_H
