/*  FreeNote for Sharp SLA300, B500, C7x0, C860 Linux PDA
	Copyright (C) 2003-2005 Joe Kanemori.<kanemori@ymg.urban.ne.jp>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
2005/06/04 FreeNote 1.11.12pre
EObh̘gۂ̑I͈͂傫\悤ɕύXB
E͈͑IAObhAKChArJ[̃JX^}CY\ɁB
EJ[sbJ[[h̒ǉ

2005/06/02 FreeNote 1.11.11Apre
EeLXgړg̕sC
ErObĥQ{ŕ\悤ɕύX
ES͈͎̔w莞ɁAyItăe|Ă͈͊m肷悤ɕύX

2005/03/18 FreeNote 1.11.10Bpre
E`̍œK

2005/02/27 FreeNote 1.11.10pre
EPDF̏o͌`ꕔύX
EC|[g̃oOfix

2005/01/04 FreeNote 1.11.6pre
EJ[u[hłW̎悤ɐ`GWP

2004/10/17 FreeNote 1.10.0[X
2004/08/26 ver 1.9.3pre
Er@\ǉ

2004/02/26 ver 1.9.0pre
EC|[g@\
 
2004/02/14 ver 1.7.2pre
E@\ǉ

2003/12/16-19 ver 1.5.5pre
Eẙg(1-8)
EAhDAhD̎
Ej[̏@ꕔ
EQuit

2003/12/14 ver 1.5.4pre
Eẙg

2003/12/04 ver 1.5.3pre
EsaveƓpdfo̓IvVǉ

2003/11/09 ver 1.5.0pre
E`[hǉ

2003/09/01-03 ver 1.3.3pre
EXN[̉
EUse all quadrant(Sیgp)j[ǉ

2003/08/17-20 FreeNote 1.3.0pre
Eaboutt^
ECR{^ǉ

2003/08/15 FreeNote 1.2.1J
Eۑ̃oOC
E_CAO̎
EPNGt@Cւ̏o

2003/08/15 FreeNote 1.2J
EIvVǉ
EXN[KCh
EFreet@C֘At
EACR̕ύX

2003/08/05 FreeNote 1.1.1preJ
ENɕԂێ
E`惂[hؑւɏS\
EۑԒZk
EView[h̋ύX
Ej[̌ڂύX
*/
#ifndef FRMMAIN_H
#define FRMMAIN_H
#include <qmainwindow.h>
#include <qcanvas.h>
#include <qscrollbar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qaction.h>
#include <qspinbox.h>
#include <qtimer.h>
#include <qimage.h>
#include <qcheckbox.h>
#include <qpe/qpemenubar.h>
#include <qpe/qpetoolbar.h>
#include "fnfiledialog.h"
#include "fncanvas.h"
#include "fnoptiondata.h"
#include "fncolordialog.h"

class FrmMain : public QMainWindow
{
    Q_OBJECT
public:
    FrmMain( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~FrmMain();
    void open(const QString& fname);
protected:
	virtual void keyPressEvent(QKeyEvent* evt);

public slots:
    void setDocument(const QString& fname);
	void modeChanged(int id);
	void modeMenuChanged(int mode);

private slots:
	void setup();
	void qcop_receive(const QCString& msg, const QByteArray& data);
	void showFullScreen();
	void setViewMode(bool flg);
	void colorSelectorPopup();
	void showLayer();

	void scroll();
	void undo();
	void save();
	void saveAs();
	void load();
	void import();
	void exportPDF();
	void exportPNG();
	void scrollbarChange(int x, int y);
	void clear();
	void newPage();
	void showGuide(bool flg);
	void about();
	void hitRet();
	void showRuler();
	void useAllQuadrant();
	void toggleSaveNPdf();
	virtual void raise() {
		QWidget::raise();
		_canvas->redraw();
	};
	void toggleTinyPaging();
	void moveAboveLayer();
	void moveBelowLayer();
	void addLayer();

	void quit();
	void scroll_menu_selected(QAction*);
	void penSelected(int id);

	void tool(int id);
	void tool1() {tool(0);};
	void tool2() {tool(1);};
	void tool3() {tool(2);};
	void tool4() {tool(3);};
	void tool5() {tool(4);};
	void tool6() {tool(5);};
	void tool7() {tool(6);};
	void tool8() {tool(7);};
	void setTitle(QFileInfo* file = NULL);
	virtual void changeColor(QRgb c);

protected:
    void closeEvent(QCloseEvent *e);
private:
	void init();
	void setOptions(const FNOptionData& o);

	QToolButton* newToolButton(QWidget* parent, const char** icon1, const char** icon2, const QString& textLabel, const bool isVGA, bool isToggle = false, bool isOn = false, int width = 32);
	QToolButton* newToolButton(QWidget* parent, const char** icon, const QString& textLabel, const bool isVGA, bool isToggle = false, bool isOn = false, int width = 32);
	QPixmap makePenPixmap(int n);

	FNCanvas* _canvas;
	QScrollBar* _vscb;
	QScrollBar* _hscb;

	QPEMenuBar* _menubar;
	QPopupMenu* _file_menu;
	QPopupMenu* _main_menu;
	QFileInfo _file;

	QPopupMenu* _scroll_menu;
	QPopupMenu* _export_menu;
	QPopupMenu* _pen_menu;
	QPopupMenu* _draw_menu;
	QPopupMenu* _edit_menu;
	QPopupMenu* _tool_menu;
	QPopupMenu* _layer_menu;
	
	QToolButton* _btnLMvA;
	QToolButton* _btnLMvB;
	QToolButton* _btnLAdd;
	QToolButton* _btnFind;
	QToolButton* _btnNew;
	QToolButton* _btnClear;
	QToolButton* _btnGuide;

	QToolButton* _btnCopy;
	QToolButton* _btnPaste;
	QToolButton* _btnImport;
	QToolButton* _btnUndo;
	QToolButton* _btnRedo;
	QCheckBox*   _chkFill;
	FNColorPalette* _btnColor;

	QToolButton* _btnZoom;
	QToolButton* _btnMaximized;

	QToolButton* _btnSave;
	QToolButton* _btnRet;

	QPEToolBar* _page_tool;
	QToolButton* _btnLoad;
	QToolButton* _btnExportPDF;
	QToolButton* _btnExportPNG;
	QToolButton* _btnLayer;
	FNOptionData _options;
	QAction* _as_both;
	QAction* _as_vert;
	QAction* _as_horz;

	int _id_toolbar;
	int _id_guide;
	int _id_maximized;
	int _id_mode;
	int _id_pen;
	int _id_pensize;
	int _id_saveNPdf;
	int _id_quadrant;
	int _id_ruler;
	int _id_tinyPaging;
	
	int _id_tool1;
	int _id_tool2;
	int _id_tool3;
	int _id_tool4;
	int _id_tool5;
	int _id_tool6;
	int _id_tool7;
	int _id_tool8;

	int _drawMode;
	int _scrollMode;

	bool _useAllQuadrant;
	bool _showRuler;
	bool _isFullscreen;
	bool _isLocked;
	bool _isTinyPaging;
	bool _isTracking;
	QString _prefile;
	QString _prepng;
	QString _prepdf;
	QString _title;
	FNColorDialog* _colorSelector;
};
#endif // FRMMAIN_H
